// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"
#include "ExperienceFunctionLibrary.generated.h"

/**
 *
 */
UCLASS()
class EXPERIENCE_UNREAL_API UExperienceFunctionLibrary : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()

	UFUNCTION(BlueprintPure, BlueprintCallable, Category = "Portal")
		static float CaculateFOVFromPlayerCamera(const APlayerController* playerController = nullptr);

	UFUNCTION(BlueprintCallable, Category = "Portal")
		static void UpdatePortalCaptureTransform(USceneComponent* captureComponent, const FTransform& cameraTransform, const USceneComponent* portalScene, const USceneComponent* teleportTargetScene);

	UFUNCTION(BlueprintCallable, Category = "Portal")
		static void UpdatePortalVPMParameter(USceneCaptureComponent2D* captureComponent, UMaterialInstanceDynamic* materialInstance, const FTransform& cameraTransform);


};
